*:*********************************************************************
*:
*:        Program: SYSDEF.PRG
*:
*:         System: System Definition Program
*:         Author: Bill Ferguson ("fergie" on ATBBS)
*:      Copyright (c) 1990, Bill Ferguson
*:  Last modified: 05/25/90     11:37
*:
*:  Procs & Fncts: HELP
*:               : S_SYSDEF
*:               : S_HELP
*:               : U_MAKE_M()
*:               : C_SYSDEF
*:               : C_HELP
*:               : EMPTY()
*:               : TOGGLE
*:               : CENTER()
*:               : SHADOW
*:               : SHADOWG
*:               : EXPLODE
*:               : SHRINK
*:
*:          Calls: HELP           (procedure in SYSDEF.PRG)
*:               : S_SYSDEF       (procedure in SYSDEF.PRG)
*:               : S_HELP         (procedure in SYSDEF.PRG)
*:               : U_MAKE_M()     (function  in SYSDEF.PRG)
*:               : C_SYSDEF       (procedure in SYSDEF.PRG)
*:               : C_HELP         (procedure in SYSDEF.PRG)
*:
*:           Uses: SYSDEF.DBF     
*:               : &DRIVER.DBF    
*:
*:    Other Files: &G_PRIN_PRT
*:
*:      Documented 05/25/90 at 11:47                SNAP!  version 4.02d
*:*********************************************************************
********************************************************************************
*-- Name.......: SYSDEF.PRG
*-- Author.....: Bill Ferguson
*--              BF Computer Solutions
*--              391 E. 118th Pl.
*--              Northglenn, CO 80233
*-- Date.......: 5-04-90
*-- Version....: dBASE IV
*-- Notes......: Generic program for allowing end-users to configure their own
*-- ...........: particular hardware environment.
********************************************************************************

SET TALK OFF
SET STATUS OFF
SELECT I
USE sysdef
*------ declare global variables -----------------------------------------------
PUBLIC g_norm_clr, g_mess_clr, g_tit_clr, g_box_clr, g_high_clr, g_info_clr
PUBLIC g_fiel_clr, g_prin_prt
PRIVATE lc_cat, lc_dbf, lc_order, t, l, B, R
t = 5
l = 6
B = 15
R = 74

*------ find current settings to display in fields -----------------------------
loffset  = _PLOFFSET
lmargin  = _LMARGIN
*plength  = _plength
pspacing = _PSPACING
peject   = _PEJECT
pwait    = _PWAIT
ppitch   = _PPITCH
pquality = _PQUALITY
curr_drvr = driver
ON KEY LABEL f2 ?? CHR(7)             && disable the standard edit function key
DO s_sysdef
ON KEY LABEL f1 DO HELP WITH VARREAD()
DO s_help

*-- @ SAY GETS Processing. -----------------------------------------------------

@ 1,27 SAY "SYSTEM & PRINTER DEFINITIONS"
* @ 2,27 SAY "      (Screen #1)"
@ 3,8 SAY "Printer Make & Model:"
@ 3,31 GET make_model PICTURE "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" ;
   VALID u_make_m( make_model )
@ 4,8 SAY "Printer Port in use :"
@ 4,31 GET print_port PICTURE "@M LPT1,COM1"
@ 6,4 SAY "Page Settings"
@ 7,1 TO 7,19 DOUBLE
@ 8,1 SAY "Page offset   :"
@ 8,18 GET loffset PICTURE "99" DEFAULT 0
@ 9,1 SAY "Left margin   :"
@ 9,18 GET lmargin PICTURE "99" DEFAULT 0
@ 10,1 SAY "Page length   :"
@ 10,18 GET plength PICTURE "99" RANGE 1,99
@ 11,1 SAY "Line spacing  :"
@ 11,19 GET pspacing PICTURE "9" RANGE 1,3

@ 6,44 SAY "Print Settings"
@ 7,25 TO 7,77 DOUBLE
@ 8,25 SAY "Eject paper       :"
@ 8,46 GET peject PICTURE "@M BEFORE,AFTER,BOTH,NONE"
@ 8,54 SAY "spacebar toggles options"
@ 9,25 SAY "Wait between pages:"
@ 9,46 GET pwait PICTURE "L"
@ 10,25 SAY "Pitch             :"
@ 10,46 GET ppitch PICTURE "@M DEFAULT,PICA,ELITE,CONDENSED"
@ 10,57 SAY "space toggles options"
@ 11,25 SAY "Print quality     :"
@ 11,46 GET pquality PICTURE "L"


@ 13,29 SAY "Screen & Color Settings"
@ 14,1 TO 14,78 DOUBLE
@ 15,3 SAY "Normal color   :"
@ 15,21 GET norm_color PICTURE "!!!!!!!"
@ 16,3 SAY "Titles color   :"
@ 16,21 GET tit_color PICTURE "!!!!!!!"
@ 17,3 SAY "Highlight color:"
@ 17,21 GET high_color PICTURE "!!!!!!!"
@ 15,45 SAY "Message color:"
@ 15,61 GET mess_color PICTURE "!!!!!!!"
@ 16,45 SAY "Box color    :"
@ 16,61 GET box_color PICTURE "!!!!!!!"
@ 17,45 SAY "Field color  :"
@ 17,61 GET fiel_color PICTURE "!!!!!!!"
@ 18,21 SAY "Information color:"
@ 18,41 GET info_color PICTURE "!!!!!!!"

@ 19,14 SAY "COLOR FORMAT: <foreground color> / <background color>"
@ 20,6 SAY "Black = N"
@ 20,18 SAY "Blue  = B"
@ 20,30 SAY "Green = G"
@ 20,42 SAY "Cyan = BG"
@ 20,54 SAY "Gray = N+"
@ 20,66 SAY "Red = R"
@ 21,6 SAY "Magenta = RB"
@ 21,26 SAY "Brown = GR"
@ 21,45 SAY "Yellow = GR+"
@ 21,64 SAY "White = W"
@ 22,12 SAY "Example: G/B means = GREEN letters on a BLUE background."
READ
STORE make_model TO KEY
SELECT J
FIND &key
REPLACE i->driver WITH j->driver
SELECT I
*------------------------------------------------------------------------------
* Code here can/should be changed. Maybe require user to load all available
* printer drivers with application as this code is made under the assumption
* that all printer drivers are supplied on one disk.
IF curr_drvr # driver
   CLEAR
   @ 13,10 SAY "Insert the printer driver disk in the 'A' drive and press ENTER"
   @ 17,00 SAY ''
   WAIT
   COPY FILE A:&driver
ENDIF
*------- Now store the above information to system variables -----------------
_PDRIVER  = driver
_PLOFFSET = loffset
_LMARGIN  = lmargin
_PLENGTH  = plength
_PSPACING = pspacing
_PEJECT   = peject
_PWAIT    = pwait
_PPITCH   = ppitch
_PQUALITY = pquality
*------- Now for global variables
g_norm_clr = i->norm_color
g_mess_clr = i->mess_color
g_tit_clr  = i->tit_color
g_box_clr  = i->box_color
g_high_clr = i->high_color
g_info_clr = i->info_color
g_fiel_clr = i->fiel_color
g_prin_prt = i->print_port
*------- Now set colors as specified ------------------------------------------
SET COLOR OF NORMAL TO &g_norm_clr
SET COLOR OF MESSAGE TO &g_mess_clr
SET COLOR OF TITLE TO &g_tit_clr
SET COLOR OF BOX TO &g_box_clr
SET COLOR OF HIGHLIGHT TO &g_high_clr
SET COLOR OF INFORMATION TO &g_info_clr
SET COLOR OF FIELDS TO &g_fiel_clr
SET PRINTER TO &g_prin_prt

*-- file exit code --------------------------------------------------------------

DO c_sysdef
DO c_help
ON KEY LABEL f1
ON KEY LABEL f2
SET PROCEDURE TO


*------------------------------------------------------------------------------
*-- Notes...: Procedures for VALID POPUPs and/or Context Sensitive Help
*-- ........: for SYSDEF.FMT
*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: S_SYSDEF
*!
*!      Called by: SYSDEF.PRG                    
*!
*!           Uses: PRINTERS.DBF   
*!
*!      MDX files: PRINTERS.MDX
*!
*!*********************************************************************
PROCEDURE s_sysdef  && Open files and Define POPUPs
USE printers  ORDER make_model IN J again

DEFINE POPUP u_make_m FROM 3,31 TO 21,74 PROMPT FIELD make_model ;
   MESSAGE "Select from list using ENTER, cancel selection with ESC"

ON SELECTION POPUP u_make_m DEACTIVATE POPUP

SELECT I

*-- EOP: s_SYSDEF
RETURN

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: C_SYSDEF
*!
*!      Called by: SYSDEF.PRG                    
*!
*!           Uses: IN.DBF         
*!
*!*********************************************************************
PROCEDURE c_sysdef  && Close files and Release POPUPs
USE IN J

RELEASE POPUP u_make_m

SELECT I

*-- EOP: c_SYSDEF
RETURN

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!       Function: EMPTY()
*!
*!*********************************************************************
FUNCTION EMPTY                && Determine if the passed argument is NULL
PARAMETER X
mtype = TYPE("x")
DO CASE
CASE mtype = "C"
   retval = (LEN(TRIM(X))=0)
CASE mtype$"NF"
   retval = (X=0)
CASE mtype = "D"
   retval = (" "$DTOC(X))
ENDCASE
*-- EOP: empty
RETURN (retval)

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!       Function: U_MAKE_M()
*!
*!      Called by: SYSDEF.PRG                    
*!
*!          Calls: SHADOWG        (procedure in SYSDEF.PRG)
*!
*!*********************************************************************
FUNCTION u_make_m
PARAMETER fld_name

esckey = 27                          && 27 represents the ESC key

SELECT J                       && Select the lookup file

SEEK TRIM(fld_name)
IF .NOT. FOUND()
   
   SAVE SCREEN TO systemp        && a UDF (UnDocumented Feature) uses 4K
   DO shadowg WITH 3,31,21,74
   ACTIVATE POPUP u_make_m
   RESTORE SCREEN FROM systemp
   RELEASE SCREEN systemp        && have to free up the 4K save screen uses
   
   IF LASTKEY() <> esckey
      rtn_fld = PROMPT()
      @ 3,31 GET rtn_fld PICTURE "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      CLEAR GETS
      
      REPLACE i->make_model WITH rtn_fld
      SELECT I
      RETURN (.T.)
   ELSE
      SELECT I
      RETURN (.F.)
   ENDIF
   
ELSE
   SELECT I
   RETURN (.T.)
ENDIF

SELECT I                             && Go back to the edit file

*-- EOP: U_make_m
RETURN (.F.)

*------------------------------------------------------------------------------

*!*********************************************************************
*!
*!      Procedure: S_HELP
*!
*!      Called by: SYSDEF.PRG                    
*!
*!          Calls: TOGGLE         (procedure in SYSDEF.PRG)
*!
*!           Uses: SYSDEF_H.DBF   
*!
*!      MDX files: SYSDEF_H.MDX
*!
*!*********************************************************************
PROCEDURE s_help
*-- Opens the HELP .dbf file
PRIVATE lc_cat, lc_dbf, lc_order, t, l, B, R
t = 5
l = 6
B = 15
R = 74
DEFINE WINDOW z_help FROM t+1,l+1 TO B-1,R-1 NONE
ON KEY LABEL f3 DO toggle
ON ERROR mvar=ERROR()
SELECT H
lc_cat = SET("CATALOG")
lc_dbf = DBF()                                  && Grab dbf if any
lc_order = ORDER()                              && Same for ORDER
USE sysdef_h ORDER fld_name noupdate            && Open HELP .dbf
SELECT I
RETURN
*-- EOP: s_Help

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: C_HELP
*!
*!      Called by: SYSDEF.PRG                    
*!
*!           Uses: IN.DBF         
*!               : (LC_DBF).DBF   
*!
*!*********************************************************************
PROCEDURE c_help
*-- Closes the HELP .dbf file
USE IN H
IF lc_cat = "ON"
   SET CATALOG TO (lc_dbf)
ELSE
   SELECT H
   IF "" <> lc_dbf                                 && If there was a dbf reopen it
      USE (lc_dbf)
   ENDIF
   IF "" <> lc_order
      SET ORDER TAG &lc_order.                     && Same for index.
   ENDIF
ENDIF
ON KEY LABEL f3
RELEASE WINDOW z_help
ON ERROR
RELEASE lc_cat, lc_dbf, lc_order, t, l, B, R
SELECT I
RETURN
*-- EOP: c_Help

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: HELP
*!
*!      Called by: SYSDEF.PRG                    
*!
*!          Calls: SHADOWG        (procedure in SYSDEF.PRG)
*!               : EXPLODE        (procedure in SYSDEF.PRG)
*!               : SHRINK         (procedure in SYSDEF.PRG)
*!
*!*********************************************************************
PROCEDURE HELP
*-- Activates the HELP window
PARAMETER lc_var                 && value returned by VARREAD()
SELECT H
SEEK lc_var
IF FOUND()                       && If found, show Help
   SAVE SCREEN TO zz_help        && a UDF (UnDocumented Feature) uses 4K
   DO shadowg WITH t,l,B,R
   DO explode WITH t,l,B,R
   
   @ t,l TO B,R DOUBLE
   ln_memline = SET("MEMO")
   SET MEMOWIDTH TO 65
   IF MEMLINES(fld_help) > 9
      @ t+1,R SAY CHR(24)
      @ B-1,R SAY CHR(25)
   ENDIF
   lc_string = [ Help for ] + TRIM(fld_headng) +[ ]
   @ t,CENTER(lc_string,80) SAY lc_string
   @ 0,0 GET fld_help OPEN WINDOW z_help ;
      MESSAGE "Scroll thru Help: Ctrl-Home   Exit Viewing Help: Ctrl-End   See Org. Screen: F3"
   READ
   SET MEMOWIDTH TO ln_memline
   DO shrink WITH t,l,B,R
   RESTORE SCREEN FROM zz_help
   RELEASE SCREEN zz_help
ENDIF
SET MESSAGE TO
SELECT I                                        && Back to edit work area
RETURN
*-- EOP: HELP

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: TOGGLE
*!
*!      Called by: S_HELP         (procedure in SYSDEF.PRG)
*!
*!*********************************************************************
PROCEDURE toggle
*-- Toggles the Help message back to the original screen
SAVE SCREEN TO toggle        && a UDF (UnDocumented Feature) uses 4K
RESTORE SCREEN FROM zz_help
SET MESSAGE TO "Press any key..."
mwait = INKEY(15)
RESTORE SCREEN FROM toggle
RELEASE SCREEN toggle
SET MESSAGE TO "Scroll thru Help: Ctrl-Home   Exit Viewing Help: Ctrl-End   See Org. Screen: F3"
RETURN
*-- EOP: Toggle

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!       Function: CENTER()
*!
*!*********************************************************************
FUNCTION CENTER
*-- UDF to center a string.
*-- lc_string = String to center
*-- ln_width = Width of screen to center in
*--
*-- Ex. @ 15,center(string,80) say string
*-- Will center the <string> within 80 columns
PARAMETER lc_string, ln_width
RETURN ((ln_width/2)-(LEN(lc_string)/2))
*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: SHADOW
*!
*!*********************************************************************
PROCEDURE SHADOW                        && displays shadow
PARAMETER x1,y1,x2,y2,dfill

IF dfill                              && use fill command not window
   
   @ x1+1,y1+2 FILL TO x2+1,y2+2 COLOR N+/N
   
ELSE                                  && define shadow window
   
   DEFINE WINDOW shadow_win FROM x1+1,y1+2 TO x2+1,y2+2 NONE COLOR N+/N
   ACTIVATE WINDOW shadow_win
   
ENDIF

RETURN
*-- EOP: shadow

*------------------------------------------------------------------------------
*!*********************************************************************
*!
*!      Procedure: SHADOWG
*!
*!      Called by: HELP           (procedure in SYSDEF.PRG)
*!               : U_MAKE_M()     (function  in SYSDEF.PRG)
*!
*!*********************************************************************
PROCEDURE shadowg                       && displays shadow that grows
PARAMETER x1,y1,x2,y2
* x1 = Top Right Corner
* y1 = Top Left  Corner
* x2 = Bottom Right Corner
* x3 = Bottom Left  Corner


x0 = x2+1
y0 = y2+2
dx = 1
dy = (y2-y1) / (x2-x1)
DO WHILE x0 <> x1 .OR. y0 <> y1+2
   
   @ x0,y0 FILL TO x2+1,y2+2 COLOR N+/N
   x0 = IIF(x0<>x1,x0 - dx,x0)
   y0 = IIF(y0<>y1+2,y0 - dy,y0)
   y0 = IIF(y0<y1+2,y1+2,y0)
ENDDO

RETURN
*-- EOP: shadowg
* Program...: EXPLODIN.PRG
* Author....: Steve Silverwood
* Date......: 11/17/1989
* Versions..: dBASE IV 1.0
* Notes.....: Illustrates making windows appear to "explode" from a
*             position on the screen to the desired dimensions.
*  MODIFIED 8 MAY 90 BY CARL R. PERKINS, NJ5J DATASMITH INC.

*!*********************************************************************
*!
*!      Procedure: EXPLODE
*!
*!      Called by: HELP           (procedure in SYSDEF.PRG)
*!
*!*********************************************************************
PROCEDURE explode
ON ERROR RETURN
* ? "Exploding a window..."

PRIVATE tl_v, tl_h, br_v, br_h, counter

* tl_v = 11     && Top left vertical start/end position.
* tl_h = 39     && Top left horizontal start/end position.
* br_v = 13     && Bottom right vertical start/end position.
* br_h = 41     && Bottom right horizontal start/end position.

DO WHILE (tl_v >= 3) .AND. (tl_h >= 23) .AND. (br_v <= 21) .AND. (br_h <= 57)
   DEFINE WINDOW boom FROM tl_v,tl_h TO br_v,br_h
   ACTIVATE WINDOW boom
   tl_v = tl_v - 1
   tl_h = tl_h - 2
   br_v = br_v + 1
   br_h = br_h + 2
ENDDO
DEACTIVATE WINDOW boom
RELEASE WINDOW boom
RETURN
*-- EOP: EXPLODE

*!*********************************************************************
*!
*!      Procedure: SHRINK
*!
*!      Called by: HELP           (procedure in SYSDEF.PRG)
*!
*!*********************************************************************
PROCEDURE shrink
* Program...: EXPLODIN.PRG   && This came out of the original program
* Author....: Steve Silverwood
* Date......: 11/17/1989
* Versions..: dBASE IV 1.0
* Notes.....: Illustrates making windows appear to "explode" from a
*             position on the screen to the desired dimensions.
*  MODIFIED 8 MAY 90 BY CARL R. PERKINS, NJ5J DATASMITH INC.
*  Added parameter statement to pass varibles to window coordinates
*  on 22 May '90 , Bill Ferguson, ("fergie" on ATBBS)
PARAMETERS tl_v, tl_h, br_v, br_h

ON ERROR RETURN

PRIVATE tl_v, tl_h, br_v, br_h

tl_v = 11     && Top left vertical start/end position.
tl_h = 39     && Top left horizontal start/end position.
br_v = 13     && Bottom right vertical start/end position.
br_h = 41     && Bottom right horizontal start/end position.


DO WHILE (tl_v <= 11) .AND. (tl_h <= 39) .AND. (br_v >= 13) .AND. (br_h >= 41)
   DEFINE WINDOW boom FROM tl_v,tl_h TO br_v,br_h
   ACTIVATE WINDOW boom
   tl_v = tl_v + 1
   tl_h = tl_h + 2
   br_v = br_v - 1
   br_h = br_h - 2
ENDDO

DEACTIVATE WINDOW boom
RELEASE WINDOW boom
RETURN
*-- EOP: SHRINK

*-- EOP: SYSDEF.PRG

*: EOF: SYSDEF.PRG
